(* This module is part of the bachelor thesis "Lambda-Interpreter", *)
(* written by Michael Brunner and supervised by Christian Sternagel, *)
(* University of Innsbruck, Institute of Computer Science *)
(* Date: 01.02.2009 *)
(* Copyright 2009 Michael Brunner, you may use this code or parts *)
(* of it as long as you keep this copyright notice in tact *)

open Monad;;


module ExceptionT (M: MONAD): sig 
	include MONAD;;
(*	type 'a t;;
  val (>>=): 'a t -> ('a -> 'b t) -> 'b t;;
  val (>>): 'a t -> 'b t -> 'b t;;
  val return: 'a -> 'a t;;*)
  val raise: string -> 'a t;;
  val trywith: 'a t -> (string -> 'a t) -> 'a t;;
(*  val run: 'a t -> 'a;;*)
  val lift: 'a M.t -> 'a t;;
end;;


module StateT (S: TYPEWRAPPER) (M: MONAD) : sig 
	include MONAD;;
(*	type 'a t;;
  val (>>=): 'a t -> ('a -> 'b t) -> 'b t;;
  val (>>): 'a t -> 'b t -> 'b t;;
  val return: 'a -> 'a t;;*)
  val read_state: S.t t;;
  val write_state: S.t -> unit t;;
(*  val run: 'a t -> 'a;;*)
  val run_with: 'a t -> S.t -> 'a;;
  val lift: 'a M.t -> 'a t;;
end;;
