(* This module is part of the bachelor thesis "Lambda-Interpreter", *)
(* written by Michael Brunner and supervised by Christian Sternagel, *)
(* University of Innsbruck, Institute of Computer Science *)
(* Date: 01.02.2009 *)
(* This module was written by Christian Sternagel, some minor*)
(* additions were made by Michael Brunner. *)

type 'a t
val diff : 'a t -> 'a t -> 'a t
val empty : 'a t
val filter : ('a -> bool) -> 'a t -> 'a t
val insert : 'a -> 'a t -> 'a t
val is_empty : 'a t -> bool
val mem : 'a -> 'a t -> bool
val fold: ('a -> 'b -> 'b) -> 'b -> 'a t -> 'b
val remove : 'a -> 'a t -> 'a t
val of_list : 'a list -> 'a t
val print_st :
 (Format.formatter -> 'a -> unit) -> Format.formatter -> 'a t -> unit
val singleton : 'a -> 'a t
val to_list : 'a t -> 'a list
val union : 'a t -> 'a t -> 'a t

val has_one : ('a -> bool) -> 'a t -> bool
val find_by : ('a -> bool) -> 'a t -> 'a
val remove_by : ('a -> bool) -> 'a t -> 'a t
val replace_by : ('a -> bool) -> 'a -> 'a t -> 'a t